stages:
  - build
  - bump
  - release

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == "master"

variables:
  TYPE: code-quality
  KIND: format
  NAME: black

before_script:
  - export BUMPED_VERSION=v0.1.0-ALPHA1
  - export CI_ACTION=`echo ${CI_COMMIT_MESSAGE} | awk -F"[][]" '{print $2}'`

bumpversion:
  stage: bump
  image:
    name: registry.gitlab.com/bswrundquist/utils/versioning/bump
    entrypoint: [""]
  script:
    - bump --type [lhs|middle|rhs|promote|release] --version v0.1.0-ALPHA1
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: never # Change ...
    - when: never

build_docker:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor@sha256:5a6b3193506212ea7703214bf3b21cd898e5e2ec14d6b988cc9d11a9b34f32d4
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor
      --context $CI_PROJECT_DIR
      --dockerfile $CI_PROJECT_DIR/Dockerfile
      --destination $CI_REGISTRY_IMAGE:$BUMPED_VERSION
      --destination $CI_REGISTRY_IMAGE:latest
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: always
    - if: $CI_ACTION == "build"
      when: always
    - when: never

release_job:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script:
    - echo 'running release_job'
  release:
    name: 'Release $BUMPED_VERSION'
    description: '$CI_COMMIT_MESSAGE'
    tag_name: 'release-$CI_COMMIT_SHA'
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: always
    - when: never